# es_ai_inference Compilation and Usage Guide

This guide provides instructions on how to compile and run `es_ai_inference` for MobilenetV2 and ResNet50 inference demos.

## 1. Compilation of `es_ai_inference` for MobilenetV2 & ResNet50

### Steps to Compile:

1. First, ensure that the `build.sh` script has execution permissions:
```shell {.line-numbers}
chmod a+x build.sh
```

2. Then, execute the build script, specifying the system root directory <sys_root_dir>:
```shell {.line-numbers}
./build.sh <sys_root_dir>
```
## Usage Instructions
```shell {.line-numbers}
eswin@rockos-eswin:~$ /opt/eswin/sample-code/npu_mobilenetv2_sample/bin/es_ai_inference
Error: Model path (-m) is required.
usage: es_ai_inference --model=string --config=string [options] ...
options:
-m, --model                path to a model file (string)
-c, --config               preprocess configuration (string)
-C, --classes              classes info file(string), classify network need specify
-p, --postprocess          postProcess info, default is classify process
-i, --input-dir            the directory of each inputs (folders) located (string [=])
-o, --output-dir           the directory of each outputs (folders) will saved in (string [=])
-l, --list                 the list of inputs which will test (string [=])
-d  --display-pic          display the image on the screen
-?, --help                 print this message
```

## Examples

#### Example 1: Resnet50 without Image Display
Run the program as instructed. This mode runs the Resnet50 inference without displaying any images.

```shell {.line-numbers}
/opt/eswin/sample-code/npu_sample/npu_resnet50_sample/bin/es_ai_inference -m /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/resnet50_int8_4x224x224x3.model -c /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/es_resnet50_pre_process.json -C /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/es_resnet50_classes.txt -p /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/es_resnet50_post_process.json -i /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/input/ -l /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/src/list.txt
```

#### Example 2: Resnet50 with Image Display
Choose to display images during the inference process. Follow the prompts to see the results along with images.

```shell {.line-numbers}
sudo -E /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/bin/es_ai_inference -m /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/resnet50_int8_4x224x224x3.model -c /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/es_resnet50_pre_process.json -C /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/es_resnet50_classes.txt -p /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/es_resnet50_post_process.json -i /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/models/input/ -l /opt/eswin/sample-code/npu_sample/npu_resnet50_sample/src/list.txt -d
```