// Copyright (c) 2023 ESWIN Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef ESWIN_HOST_RUNTIME_INCLUDE_DEVICE_H_
#define ESWIN_HOST_RUNTIME_INCLUDE_DEVICE_H_

#include <string>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
#include "es_npu_types.h"

namespace eswin
{

typedef struct _deviceInfo {
    uint16_t runMode;
    uint16_t deviceNum;
    char devDescribe[20];
} deviceInfo_t;

int32_t getDeviceProperties(int32_t deviceId, NPU_DEVICE_PROP_S *prop);
int32_t getNumDevices(uint16_t *deviceNum);
int32_t getDevice(uint16_t *deviceId);
int32_t setDevice(uint16_t deviceId);
int32_t releaseDevice(uint16_t deviceId);

}  // namespace eswin

#endif  // ESWIN_HOST_RUNTIME_INCLUDE_DEVICE_H_
