// Copyright (c) 2023 ESWIN Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef ESWIN_HOST_RUNTIME_INCLUDE_EPOLLWRAPPER_H_
#define ESWIN_HOST_RUNTIME_INCLUDE_EPOLLWRAPPER_H_

#include <map>
#include <vector>
namespace eswin
{
enum {
    COMPLETE = 1,
    TIME_OUT,
};

class IHWProcessor;
class EpollWrapper
{
 public:
    EpollWrapper();
    ~EpollWrapper();

    int32_t registerEpollHandle(int32_t fd, IHWProcessor* processor);
    int32_t unRegisterEpollHandle(int32_t fd);
    int32_t waitEvents(int32_t maxEvents, int32_t timeoutMs);

 private:
    int32_t mEpollFd;
};
}  // namespace eswin
#endif  // ESWIN_HOST_RUNTIME_INCLUDE_EPOLLWRAPPER_H_