// Copyright (c) 2023 ESWIN Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#ifndef ESWIN_HOST_RUNTIME_INCLUDE_HAEPROCESSOR_H_
#define ESWIN_HOST_RUNTIME_INCLUDE_HAEPROCESSOR_H_

#include "iHWProcessor.h"
#include "opThreadScheduler.h"
namespace eswin
{
////////////////////////////////////////////////////////////////////////////////
// Class HaeOpThreadScheduler implementation
class HaeOpThreadScheduler : public OpThreadScheduler
{
 public:
    int32_t submitOpTask(opTaskDesc_t *opTask) override;
    int32_t setContext(npu_context context);

 private:
    npu_context mCtx = nullptr;
};

///////////////////////////////////////////////////////////////////////////////
// Class HaeProcessor implementation
class HaeProcessor : public IHWProcessor
{
 public:
    explicit HaeProcessor(int32_t devId);
    ~HaeProcessor();

    int32_t open() override;
    int32_t close() override;

    int32_t processReport() override;
    int32_t getFd() override;
    int32_t submitOpTask(opTaskDesc_t *opTaskDesc) override;
    int32_t setContext(npu_context context);

 private:
    int32_t initialize();

    int32_t mFd;
    int32_t mDevId;
    HaeOpThreadScheduler mHaeOpThreadScheduler;
};
}  // namespace eswin
#endif  // #ifndef ESWIN_HOST_RUNTIME_INCLUDE_HAEPROCESSOR_H_
