// Copyright (c) 2023 ESWIN Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// automatically generated by the FlatBuffers compiler, do not modify

#ifndef ESWIN_HOST_RUNTIME_INCLUDE_LOADABLE_GENERATED_H_
#define ESWIN_HOST_RUNTIME_INCLUDE_LOADABLE_GENERATED_H_

#include <vector>
#include "flatbuffers/flatbuffers.h"

namespace eswin
{
namespace loadable
{

struct Version;

struct Blob;
struct BlobBuilder;

struct MemoryListEntry;
struct MemoryListEntryBuilder;

struct EventListEntry;
struct EventListEntryBuilder;

struct SubModelListEntry;
struct SubModelListEntryBuilder;

struct AddressListEntry;
struct AddressListEntryBuilder;

struct SubmitListEntry;
struct SubmitListEntryBuilder;

struct TensorDescListEntry;
struct TensorDescListEntryBuilder;

struct RelocListEntry;
struct RelocListEntryBuilder;

struct Loadable;
struct LoadableBuilder;

enum Interface : uint32_t {
    Interface_NONE = 0,
    Interface_UMD = 1,
    Interface_KMD = 2,
    Interface_MIN = Interface_NONE,
    Interface_MAX = Interface_KMD
};

inline const Interface (&EnumValuesInterface())[3]
{
    static const Interface values[] = {Interface_NONE, Interface_UMD, Interface_KMD};
    return values;
}

inline const char *const *EnumNamesInterface()
{
    static const char *const names[4] = {"NONE", "UMD", "KMD", nullptr};
    return names;
}

inline const char *EnumNameInterface(Interface e)
{
    if (flatbuffers::IsOutRange(e, Interface_NONE, Interface_KMD)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesInterface()[index];
}

enum LoadableVersionMajor : uint8_t {
    LoadableVersionMajor_VAL = 0,
    LoadableVersionMajor_MIN = LoadableVersionMajor_VAL,
    LoadableVersionMajor_MAX = LoadableVersionMajor_VAL
};

inline const LoadableVersionMajor (&EnumValuesLoadableVersionMajor())[1]
{
    static const LoadableVersionMajor values[] = {LoadableVersionMajor_VAL};
    return values;
}

inline const char *const *EnumNamesLoadableVersionMajor()
{
    static const char *const names[2] = {"VAL", nullptr};
    return names;
}

inline const char *EnumNameLoadableVersionMajor(LoadableVersionMajor e)
{
    if (flatbuffers::IsOutRange(e, LoadableVersionMajor_VAL, LoadableVersionMajor_VAL)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesLoadableVersionMajor()[index];
}

enum LoadableVersionMinor : uint8_t {
    LoadableVersionMinor_VAL = 7,
    LoadableVersionMinor_MIN = LoadableVersionMinor_VAL,
    LoadableVersionMinor_MAX = LoadableVersionMinor_VAL
};

inline const LoadableVersionMinor (&EnumValuesLoadableVersionMinor())[1]
{
    static const LoadableVersionMinor values[] = {LoadableVersionMinor_VAL};
    return values;
}

inline const char *const *EnumNamesLoadableVersionMinor()
{
    static const char *const names[2] = {"VAL", nullptr};
    return names;
}

inline const char *EnumNameLoadableVersionMinor(LoadableVersionMinor e)
{
    if (flatbuffers::IsOutRange(e, LoadableVersionMinor_VAL, LoadableVersionMinor_VAL)) return "";
    const size_t index = static_cast<size_t>(e) - static_cast<size_t>(LoadableVersionMinor_VAL);
    return EnumNamesLoadableVersionMinor()[index];
}

enum LoadableVersionSubMinor : uint8_t {
    LoadableVersionSubMinor_VAL = 0,
    LoadableVersionSubMinor_MIN = LoadableVersionSubMinor_VAL,
    LoadableVersionSubMinor_MAX = LoadableVersionSubMinor_VAL
};

inline const LoadableVersionSubMinor (&EnumValuesLoadableVersionSubMinor())[1]
{
    static const LoadableVersionSubMinor values[] = {LoadableVersionSubMinor_VAL};
    return values;
}

inline const char *const *EnumNamesLoadableVersionSubMinor()
{
    static const char *const names[2] = {"VAL", nullptr};
    return names;
}

inline const char *EnumNameLoadableVersionSubMinor(LoadableVersionSubMinor e)
{
    if (flatbuffers::IsOutRange(e, LoadableVersionSubMinor_VAL, LoadableVersionSubMinor_VAL)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesLoadableVersionSubMinor()[index];
}

enum MemoryDomain : uint8_t {
    MemoryDomain_SYSTEM = 0,
    MemoryDomain_SRAM = 1,
    MemoryDomain_MIN = MemoryDomain_SYSTEM,
    MemoryDomain_MAX = MemoryDomain_SRAM
};

inline const MemoryDomain (&EnumValuesMemoryDomain())[2]
{
    static const MemoryDomain values[] = {MemoryDomain_SYSTEM, MemoryDomain_SRAM};
    return values;
}

inline const char *const *EnumNamesMemoryDomain()
{
    static const char *const names[3] = {"SYSTEM", "SRAM", nullptr};
    return names;
}

inline const char *EnumNameMemoryDomain(MemoryDomain e)
{
    if (flatbuffers::IsOutRange(e, MemoryDomain_SYSTEM, MemoryDomain_SRAM)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesMemoryDomain()[index];
}

enum MemoryFlags : uint16_t {
    MemoryFlags_NONE = 0,
    MemoryFlags_ALLOC = 1,
    MemoryFlags_SET = 2,
    MemoryFlags_INPUT = 4,
    MemoryFlags_OUTPUT = 8,
    MemoryFlags_CACHE = 16,
    MemoryFlags_NO_CACHE = 32,
    MemoryFlags_MIN = MemoryFlags_NONE,
    MemoryFlags_MAX = MemoryFlags_NO_CACHE
};

inline const MemoryFlags (&EnumValuesMemoryFlags())[7]
{
    static const MemoryFlags values[] = {MemoryFlags_NONE,   MemoryFlags_ALLOC, MemoryFlags_SET,     MemoryFlags_INPUT,
                                         MemoryFlags_OUTPUT, MemoryFlags_CACHE, MemoryFlags_NO_CACHE};
    return values;
}

inline const char *const *EnumNamesMemoryFlags()
{
    static const char *const names[34] = {"NONE", "ALLOC", "SET", "", "INPUT", "", "", "", "OUTPUT",   "",     "", "",
                                          "",     "",      "",    "", "CACHE", "", "", "", "",         "",     "", "",
                                          "",     "",      "",    "", "",      "", "", "", "NO_CACHE", nullptr};
    return names;
}

inline const char *EnumNameMemoryFlags(MemoryFlags e)
{
    if (flatbuffers::IsOutRange(e, MemoryFlags_NONE, MemoryFlags_OUTPUT)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesMemoryFlags()[index];
}

enum EventType : uint8_t {
    EventType_EVENTTYPE0 = 0,
    EventType_EVENTTYPE1 = 1,
    EventType_EVENTTYPE2 = 2,
    EventType_MIN = EventType_EVENTTYPE0,
    EventType_MAX = EventType_EVENTTYPE2
};

inline const EventType (&EnumValuesEventType())[3]
{
    static const EventType values[] = {EventType_EVENTTYPE0, EventType_EVENTTYPE1, EventType_EVENTTYPE2};
    return values;
}

inline const char *const *EnumNamesEventType()
{
    static const char *const names[4] = {"EVENTTYPE0", "EVENTTYPE1", "EVENTTYPE2", nullptr};
    return names;
}

inline const char *EnumNameEventType(EventType e)
{
    if (flatbuffers::IsOutRange(e, EventType_EVENTTYPE0, EventType_EVENTTYPE2)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesEventType()[index];
}

enum EventOp : uint8_t {
    EventOp_WAIT = 0,
    EventOp_SIGNAL = 1,
    EventOp_MIN = EventOp_WAIT,
    EventOp_MAX = EventOp_SIGNAL
};

inline const EventOp (&EnumValuesEventOp())[2]
{
    static const EventOp values[] = {EventOp_WAIT, EventOp_SIGNAL};
    return values;
}

inline const char *const *EnumNamesEventOp()
{
    static const char *const names[3] = {"WAIT", "SIGNAL", nullptr};
    return names;
}

inline const char *EnumNameEventOp(EventOp e)
{
    if (flatbuffers::IsOutRange(e, EventOp_WAIT, EventOp_SIGNAL)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesEventOp()[index];
}

enum DataFormat : uint8_t {
    DataFormat_UNKNOWN = 0,
    DataFormat_NCHW = 1,
    DataFormat_NHWC = 2,
    DataFormat_MIN = DataFormat_UNKNOWN,
    DataFormat_MAX = DataFormat_NHWC
};

inline const DataFormat (&EnumValuesDataFormat())[3]
{
    static const DataFormat values[] = {DataFormat_UNKNOWN, DataFormat_NCHW, DataFormat_NHWC};
    return values;
}

inline const char *const *EnumNamesDataFormat()
{
    static const char *const names[4] = {"UNKNOWN", "NCHW", "NHWC", nullptr};
    return names;
}

inline const char *EnumNameDataFormat(DataFormat e)
{
    if (flatbuffers::IsOutRange(e, DataFormat_UNKNOWN, DataFormat_NHWC)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesDataFormat()[index];
}

enum DataType : uint8_t {
    DataType_UNKNOWN = 0,
    DataType_FLOAT = 1,
    DataType_HALF = 2,
    DataType_INT16 = 3,
    DataType_INT8 = 4,
    DataType_MIN = DataType_UNKNOWN,
    DataType_MAX = DataType_INT8
};

inline const DataType (&EnumValuesDataType())[5]
{
    static const DataType values[] = {DataType_UNKNOWN, DataType_FLOAT, DataType_HALF, DataType_INT16, DataType_INT8};
    return values;
}

inline const char *const *EnumNamesDataType()
{
    static const char *const names[6] = {"UNKNOWN", "FLOAT", "HALF", "INT16", "INT8", nullptr};
    return names;
}

inline const char *EnumNameDataType(DataType e)
{
    if (flatbuffers::IsOutRange(e, DataType_UNKNOWN, DataType_INT8)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesDataType()[index];
}

enum DataCategory : uint8_t {
    DataCategory_IMAGE = 0,
    DataCategory_WEIGHT = 1,
    DataCategory_FEATURE = 2,
    DataCategory_PLANAR = 3,
    DataCategory_BIAS = 4,
    DataCategory_MIN = DataCategory_IMAGE,
    DataCategory_MAX = DataCategory_BIAS
};

inline const DataCategory (&EnumValuesDataCategory())[5]
{
    static const DataCategory values[] = {DataCategory_IMAGE, DataCategory_WEIGHT, DataCategory_FEATURE,
                                          DataCategory_PLANAR, DataCategory_BIAS};
    return values;
}

inline const char *const *EnumNamesDataCategory()
{
    static const char *const names[6] = {"IMAGE", "WEIGHT", "FEATURE", "PLANAR", "BIAS", nullptr};
    return names;
}

inline const char *EnumNameDataCategory(DataCategory e)
{
    if (flatbuffers::IsOutRange(e, DataCategory_IMAGE, DataCategory_BIAS)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesDataCategory()[index];
}

enum PixelMapping : uint8_t {
    PixelMapping_PITCH_LINEAR = 0,
    PixelMapping_INVALID_PIXEL_MAP = 1,
    PixelMapping_MIN = PixelMapping_PITCH_LINEAR,
    PixelMapping_MAX = PixelMapping_INVALID_PIXEL_MAP
};

inline const PixelMapping (&EnumValuesPixelMapping())[2]
{
    static const PixelMapping values[] = {PixelMapping_PITCH_LINEAR, PixelMapping_INVALID_PIXEL_MAP};
    return values;
}

inline const char *const *EnumNamesPixelMapping()
{
    static const char *const names[3] = {"PITCH_LINEAR", "INVALID_PIXEL_MAP", nullptr};
    return names;
}

inline const char *EnumNamePixelMapping(PixelMapping e)
{
    if (flatbuffers::IsOutRange(e, PixelMapping_PITCH_LINEAR, PixelMapping_INVALID_PIXEL_MAP)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesPixelMapping()[index];
}

enum PixelFormat : uint8_t {
    PixelFormat_R8 = 0,
    PixelFormat_R10 = 1,
    PixelFormat_R12 = 2,
    PixelFormat_R16 = 3,
    PixelFormat_R16_I = 4,
    PixelFormat_R16_F = 5,
    PixelFormat_A16B16G16R16 = 6,
    PixelFormat_X16B16G16R16 = 7,
    PixelFormat_A16B16G16R16_F = 8,
    PixelFormat_A16Y16U16V16 = 9,
    PixelFormat_V16U16Y16A16 = 10,
    PixelFormat_A16Y16U16V16_F = 11,
    PixelFormat_A8B8G8R8 = 12,
    PixelFormat_A8R8G8B8 = 13,
    PixelFormat_B8G8R8A8 = 14,
    PixelFormat_R8G8B8A8 = 15,
    PixelFormat_X8B8G8R8 = 16,
    PixelFormat_X8R8G8B8 = 17,
    PixelFormat_B8G8R8X8 = 18,
    PixelFormat_R8G8B8X8 = 19,
    PixelFormat_A2B10G10R10 = 20,
    PixelFormat_A2R10G10B10 = 21,
    PixelFormat_B10G10R10A2 = 22,
    PixelFormat_R10G10B10A2 = 23,
    PixelFormat_A2Y10U10V10 = 24,
    PixelFormat_V10U10Y10A2 = 25,
    PixelFormat_A8Y8U8V8 = 26,
    PixelFormat_V8U8Y8A8 = 27,
    PixelFormat_Y8_U8V8_N444 = 28,
    PixelFormat_Y8_V8U8_N444 = 29,
    PixelFormat_Y10_U10V10_N444 = 30,
    PixelFormat_Y10_V10U10_N444 = 31,
    PixelFormat_Y12_U12V12_N444 = 32,
    PixelFormat_Y12_V12U12_N444 = 33,
    PixelFormat_Y16_U16V16_N444 = 34,
    PixelFormat_Y16_V16U16_N444 = 35,
    PixelFormat_FEATURE = 36,
    PixelFormat_FEATURE_X8 = 37,
    PixelFormat_MIN = PixelFormat_R8,
    PixelFormat_MAX = PixelFormat_FEATURE_X8
};

inline const PixelFormat (&EnumValuesPixelFormat())[38]
{
    static const PixelFormat values[] = {PixelFormat_R8,
                                         PixelFormat_R10,
                                         PixelFormat_R12,
                                         PixelFormat_R16,
                                         PixelFormat_R16_I,
                                         PixelFormat_R16_F,
                                         PixelFormat_A16B16G16R16,
                                         PixelFormat_X16B16G16R16,
                                         PixelFormat_A16B16G16R16_F,
                                         PixelFormat_A16Y16U16V16,
                                         PixelFormat_V16U16Y16A16,
                                         PixelFormat_A16Y16U16V16_F,
                                         PixelFormat_A8B8G8R8,
                                         PixelFormat_A8R8G8B8,
                                         PixelFormat_B8G8R8A8,
                                         PixelFormat_R8G8B8A8,
                                         PixelFormat_X8B8G8R8,
                                         PixelFormat_X8R8G8B8,
                                         PixelFormat_B8G8R8X8,
                                         PixelFormat_R8G8B8X8,
                                         PixelFormat_A2B10G10R10,
                                         PixelFormat_A2R10G10B10,
                                         PixelFormat_B10G10R10A2,
                                         PixelFormat_R10G10B10A2,
                                         PixelFormat_A2Y10U10V10,
                                         PixelFormat_V10U10Y10A2,
                                         PixelFormat_A8Y8U8V8,
                                         PixelFormat_V8U8Y8A8,
                                         PixelFormat_Y8_U8V8_N444,
                                         PixelFormat_Y8_V8U8_N444,
                                         PixelFormat_Y10_U10V10_N444,
                                         PixelFormat_Y10_V10U10_N444,
                                         PixelFormat_Y12_U12V12_N444,
                                         PixelFormat_Y12_V12U12_N444,
                                         PixelFormat_Y16_U16V16_N444,
                                         PixelFormat_Y16_V16U16_N444,
                                         PixelFormat_FEATURE,
                                         PixelFormat_FEATURE_X8};
    return values;
}

inline const char *const *EnumNamesPixelFormat()
{
    static const char *const names[39] = {"R8",
                                          "R10",
                                          "R12",
                                          "R16",
                                          "R16_I",
                                          "R16_F",
                                          "A16B16G16R16",
                                          "X16B16G16R16",
                                          "A16B16G16R16_F",
                                          "A16Y16U16V16",
                                          "V16U16Y16A16",
                                          "A16Y16U16V16_F",
                                          "A8B8G8R8",
                                          "A8R8G8B8",
                                          "B8G8R8A8",
                                          "R8G8B8A8",
                                          "X8B8G8R8",
                                          "X8R8G8B8",
                                          "B8G8R8X8",
                                          "R8G8B8X8",
                                          "A2B10G10R10",
                                          "A2R10G10B10",
                                          "B10G10R10A2",
                                          "R10G10B10A2",
                                          "A2Y10U10V10",
                                          "V10U10Y10A2",
                                          "A8Y8U8V8",
                                          "V8U8Y8A8",
                                          "Y8_U8V8_N444",
                                          "Y8_V8U8_N444",
                                          "Y10_U10V10_N444",
                                          "Y10_V10U10_N444",
                                          "Y12_U12V12_N444",
                                          "Y12_V12U12_N444",
                                          "Y16_U16V16_N444",
                                          "Y16_V16U16_N444",
                                          "FEATURE",
                                          "FEATURE_X8",
                                          nullptr};
    return names;
}

inline const char *EnumNamePixelFormat(PixelFormat e)
{
    if (flatbuffers::IsOutRange(e, PixelFormat_R8, PixelFormat_FEATURE_X8)) return "";
    const size_t index = static_cast<size_t>(e);
    return EnumNamesPixelFormat()[index];
}

FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(1) Version FLATBUFFERS_FINAL_CLASS
{
 private:
    uint8_t major_;
    uint8_t minor_;
    uint8_t sub_minor_;

 public:
    Version() : major_(0), minor_(0), sub_minor_(0) {}
    Version(uint8_t _major, uint8_t _minor, uint8_t _sub_minor)
        : major_(flatbuffers::EndianScalar(_major)),
          minor_(flatbuffers::EndianScalar(_minor)),
          sub_minor_(flatbuffers::EndianScalar(_sub_minor))
    {
    }
    uint8_t major() const { return flatbuffers::EndianScalar(major_); }
    uint8_t minor() const { return flatbuffers::EndianScalar(minor_); }
    uint8_t sub_minor() const { return flatbuffers::EndianScalar(sub_minor_); }
};
FLATBUFFERS_STRUCT_END(Version, 3);

struct Blob FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef BlobBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_NAME = 4,
        VT_SIZE = 6,
        VT_INTERFACE = 8,
        VT_SUB_INTERFACE = 10,
        VT_VERSION = 12,
        VT_DATA = 14
    };
    const flatbuffers::String *name() const { return GetPointer<const flatbuffers::String *>(VT_NAME); }
    uint64_t size() const { return GetField<uint64_t>(VT_SIZE, 0); }
    eswin::loadable::Interface interface() const
    {
        return static_cast<eswin::loadable::Interface>(GetField<uint32_t>(VT_INTERFACE, 0));
    }
    uint32_t sub_interface() const { return GetField<uint32_t>(VT_SUB_INTERFACE, 0); }
    const eswin::loadable::Version *version() const { return GetStruct<const eswin::loadable::Version *>(VT_VERSION); }
    const flatbuffers::Vector<uint8_t> *data() const
    {
        return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_DATA);
    }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyOffset(verifier, VT_NAME) && verifier.VerifyString(name()) &&
               VerifyField<uint64_t>(verifier, VT_SIZE) && VerifyField<uint32_t>(verifier, VT_INTERFACE) &&
               VerifyField<uint32_t>(verifier, VT_SUB_INTERFACE) &&
               VerifyField<eswin::loadable::Version>(verifier, VT_VERSION) && VerifyOffset(verifier, VT_DATA) &&
               verifier.VerifyVector(data()) && verifier.EndTable();
    }
};

struct BlobBuilder {
    typedef Blob Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_name(flatbuffers::Offset<flatbuffers::String> name) { fbb_.AddOffset(Blob::VT_NAME, name); }
    void add_size(uint64_t size) { fbb_.AddElement<uint64_t>(Blob::VT_SIZE, size, 0); }
    void add_interface(eswin::loadable::Interface interface)
    {
        fbb_.AddElement<uint32_t>(Blob::VT_INTERFACE, static_cast<uint32_t>(interface), 0);
    }
    void add_sub_interface(uint32_t sub_interface)
    {
        fbb_.AddElement<uint32_t>(Blob::VT_SUB_INTERFACE, sub_interface, 0);
    }
    void add_version(const eswin::loadable::Version *version) { fbb_.AddStruct(Blob::VT_VERSION, version); }
    void add_data(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> data) { fbb_.AddOffset(Blob::VT_DATA, data); }
    explicit BlobBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<Blob> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<Blob>(end);
        return o;
    }
};

inline flatbuffers::Offset<Blob> CreateBlob(flatbuffers::FlatBufferBuilder &_fbb,
                                            flatbuffers::Offset<flatbuffers::String> name = 0, uint64_t size = 0,
                                            eswin::loadable::Interface interface = eswin::loadable::Interface_NONE,
                                            uint32_t sub_interface = 0,
                                            const eswin::loadable::Version *version = nullptr,
                                            flatbuffers::Offset<flatbuffers::Vector<uint8_t>> data = 0)
{
    BlobBuilder builder_(_fbb);
    builder_.add_size(size);
    builder_.add_data(data);
    builder_.add_version(version);
    builder_.add_sub_interface(sub_interface);
    builder_.add_interface(interface);
    builder_.add_name(name);
    return builder_.Finish();
}

inline flatbuffers::Offset<Blob> CreateBlobDirect(
    flatbuffers::FlatBufferBuilder &_fbb, const char *name = nullptr, uint64_t size = 0,
    eswin::loadable::Interface interface = eswin::loadable::Interface_NONE, uint32_t sub_interface = 0,
    const eswin::loadable::Version *version = nullptr, const std::vector<uint8_t> *data = nullptr)
{
    auto name__ = name ? _fbb.CreateString(name) : 0;
    auto data__ = data ? _fbb.CreateVector<uint8_t>(*data) : 0;
    return eswin::loadable::CreateBlob(_fbb, name__, size, interface, sub_interface, version, data__);
}

struct MemoryListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef MemoryListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_ID = 4,
        VT_DOMAIN = 6,
        VT_FLAGS = 8,
        VT_SIZE = 10,
        VT_ALIGNMENT = 12,
        VT_CONTENTS = 14,
        VT_OFFSETS = 16,
        VT_BIND_ID = 18,
        VT_TENSOR_DESC_ID = 20
    };
    uint16_t id() const { return GetField<uint16_t>(VT_ID, 0); }
    eswin::loadable::MemoryDomain domain() const
    {
        return static_cast<eswin::loadable::MemoryDomain>(GetField<uint8_t>(VT_DOMAIN, 0));
    }
    eswin::loadable::MemoryFlags flags() const
    {
        return static_cast<eswin::loadable::MemoryFlags>(GetField<uint16_t>(VT_FLAGS, 0));
    }
    uint64_t size() const { return GetField<uint64_t>(VT_SIZE, 0); }
    uint32_t alignment() const { return GetField<uint32_t>(VT_ALIGNMENT, 0); }
    const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *contents() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>> *>(VT_CONTENTS);
    }
    const flatbuffers::Vector<uint64_t> *offsets() const
    {
        return GetPointer<const flatbuffers::Vector<uint64_t> *>(VT_OFFSETS);
    }
    uint16_t bind_id() const { return GetField<uint16_t>(VT_BIND_ID, 0); }
    uint16_t tensor_desc_id() const { return GetField<uint16_t>(VT_TENSOR_DESC_ID, 0); }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyField<uint16_t>(verifier, VT_ID) &&
               VerifyField<uint8_t>(verifier, VT_DOMAIN) && VerifyField<uint16_t>(verifier, VT_FLAGS) &&
               VerifyField<uint64_t>(verifier, VT_SIZE) && VerifyField<uint32_t>(verifier, VT_ALIGNMENT) &&
               VerifyOffset(verifier, VT_CONTENTS) && verifier.VerifyVector(contents()) &&
               verifier.VerifyVectorOfStrings(contents()) && VerifyOffset(verifier, VT_OFFSETS) &&
               verifier.VerifyVector(offsets()) && VerifyField<uint16_t>(verifier, VT_BIND_ID) &&
               VerifyField<uint16_t>(verifier, VT_TENSOR_DESC_ID) && verifier.EndTable();
    }
};

struct MemoryListEntryBuilder {
    typedef MemoryListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_id(uint16_t id) { fbb_.AddElement<uint16_t>(MemoryListEntry::VT_ID, id, 0); }
    void add_domain(eswin::loadable::MemoryDomain domain)
    {
        fbb_.AddElement<uint8_t>(MemoryListEntry::VT_DOMAIN, static_cast<uint8_t>(domain), 0);
    }
    void add_flags(eswin::loadable::MemoryFlags flags)
    {
        fbb_.AddElement<uint16_t>(MemoryListEntry::VT_FLAGS, static_cast<uint16_t>(flags), 0);
    }
    void add_size(uint64_t size) { fbb_.AddElement<uint64_t>(MemoryListEntry::VT_SIZE, size, 0); }
    void add_alignment(uint32_t alignment) { fbb_.AddElement<uint32_t>(MemoryListEntry::VT_ALIGNMENT, alignment, 0); }
    void add_contents(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> contents)
    {
        fbb_.AddOffset(MemoryListEntry::VT_CONTENTS, contents);
    }
    void add_offsets(flatbuffers::Offset<flatbuffers::Vector<uint64_t>> offsets)
    {
        fbb_.AddOffset(MemoryListEntry::VT_OFFSETS, offsets);
    }
    void add_bind_id(uint16_t bind_id) { fbb_.AddElement<uint16_t>(MemoryListEntry::VT_BIND_ID, bind_id, 0); }
    void add_tensor_desc_id(uint16_t tensor_desc_id)
    {
        fbb_.AddElement<uint16_t>(MemoryListEntry::VT_TENSOR_DESC_ID, tensor_desc_id, 0);
    }
    explicit MemoryListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<MemoryListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<MemoryListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<MemoryListEntry> CreateMemoryListEntry(
    flatbuffers::FlatBufferBuilder &_fbb, uint16_t id = 0,
    eswin::loadable::MemoryDomain domain = eswin::loadable::MemoryDomain_SYSTEM,
    eswin::loadable::MemoryFlags flags = eswin::loadable::MemoryFlags_NONE, uint64_t size = 0, uint32_t alignment = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<flatbuffers::String>>> contents = 0,
    flatbuffers::Offset<flatbuffers::Vector<uint64_t>> offsets = 0, uint16_t bind_id = 0, uint16_t tensor_desc_id = 0)
{
    MemoryListEntryBuilder builder_(_fbb);
    builder_.add_size(size);
    builder_.add_offsets(offsets);
    builder_.add_contents(contents);
    builder_.add_alignment(alignment);
    builder_.add_tensor_desc_id(tensor_desc_id);
    builder_.add_bind_id(bind_id);
    builder_.add_flags(flags);
    builder_.add_id(id);
    builder_.add_domain(domain);
    return builder_.Finish();
}

inline flatbuffers::Offset<MemoryListEntry> CreateMemoryListEntryDirect(
    flatbuffers::FlatBufferBuilder &_fbb, uint16_t id = 0,
    eswin::loadable::MemoryDomain domain = eswin::loadable::MemoryDomain_SYSTEM,
    eswin::loadable::MemoryFlags flags = eswin::loadable::MemoryFlags_NONE, uint64_t size = 0, uint32_t alignment = 0,
    const std::vector<flatbuffers::Offset<flatbuffers::String>> *contents = nullptr,
    const std::vector<uint64_t> *offsets = nullptr, uint16_t bind_id = 0, uint16_t tensor_desc_id = 0)
{
    auto contents__ = contents ? _fbb.CreateVector<flatbuffers::Offset<flatbuffers::String>>(*contents) : 0;
    auto offsets__ = offsets ? _fbb.CreateVector<uint64_t>(*offsets) : 0;
    return eswin::loadable::CreateMemoryListEntry(_fbb, id, domain, flags, size, alignment, contents__, offsets__,
                                                  bind_id, tensor_desc_id);
}

struct EventListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef EventListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_ID = 4,
        VT_TYPE = 6,
        VT_TARGET = 8,
        VT_VAL = 10,
        VT_OP = 12
    };
    uint16_t id() const { return GetField<uint16_t>(VT_ID, 0); }
    eswin::loadable::EventType type() const
    {
        return static_cast<eswin::loadable::EventType>(GetField<uint8_t>(VT_TYPE, 0));
    }
    uint16_t target() const { return GetField<uint16_t>(VT_TARGET, 0); }
    uint32_t val() const { return GetField<uint32_t>(VT_VAL, 0); }
    eswin::loadable::EventOp op() const { return static_cast<eswin::loadable::EventOp>(GetField<uint8_t>(VT_OP, 0)); }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyField<uint16_t>(verifier, VT_ID) &&
               VerifyField<uint8_t>(verifier, VT_TYPE) && VerifyField<uint16_t>(verifier, VT_TARGET) &&
               VerifyField<uint32_t>(verifier, VT_VAL) && VerifyField<uint8_t>(verifier, VT_OP) && verifier.EndTable();
    }
};

struct EventListEntryBuilder {
    typedef EventListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_id(uint16_t id) { fbb_.AddElement<uint16_t>(EventListEntry::VT_ID, id, 0); }
    void add_type(eswin::loadable::EventType type)
    {
        fbb_.AddElement<uint8_t>(EventListEntry::VT_TYPE, static_cast<uint8_t>(type), 0);
    }
    void add_target(uint16_t target) { fbb_.AddElement<uint16_t>(EventListEntry::VT_TARGET, target, 0); }
    void add_val(uint32_t val) { fbb_.AddElement<uint32_t>(EventListEntry::VT_VAL, val, 0); }
    void add_op(eswin::loadable::EventOp op)
    {
        fbb_.AddElement<uint8_t>(EventListEntry::VT_OP, static_cast<uint8_t>(op), 0);
    }
    explicit EventListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<EventListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<EventListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<EventListEntry> CreateEventListEntry(
    flatbuffers::FlatBufferBuilder &_fbb, uint16_t id = 0,
    eswin::loadable::EventType type = eswin::loadable::EventType_EVENTTYPE0, uint16_t target = 0, uint32_t val = 0,
    eswin::loadable::EventOp op = eswin::loadable::EventOp_WAIT)
{
    EventListEntryBuilder builder_(_fbb);
    builder_.add_val(val);
    builder_.add_target(target);
    builder_.add_id(id);
    builder_.add_op(op);
    builder_.add_type(type);
    return builder_.Finish();
}

struct SubModelListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef SubModelListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_ID = 4,
        VT_KMD_ID = 6,
        VT_INTERFACE = 8,
        VT_ADDRESS_LIST = 10
    };
    uint16_t id() const { return GetField<uint16_t>(VT_ID, 0); }
    int16_t kmd_id() const { return GetField<int16_t>(VT_KMD_ID, 0); }
    eswin::loadable::Interface interface() const
    {
        return static_cast<eswin::loadable::Interface>(GetField<uint32_t>(VT_INTERFACE, 0));
    }
    const flatbuffers::Vector<uint16_t> *address_list() const
    {
        return GetPointer<const flatbuffers::Vector<uint16_t> *>(VT_ADDRESS_LIST);
    }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyField<uint16_t>(verifier, VT_ID) &&
               VerifyField<int16_t>(verifier, VT_KMD_ID) && VerifyField<uint32_t>(verifier, VT_INTERFACE) &&
               VerifyOffset(verifier, VT_ADDRESS_LIST) && verifier.VerifyVector(address_list()) && verifier.EndTable();
    }
};

struct SubModelListEntryBuilder {
    typedef SubModelListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_id(uint16_t id) { fbb_.AddElement<uint16_t>(SubModelListEntry::VT_ID, id, 0); }
    void add_kmd_id(int16_t kmd_id) { fbb_.AddElement<int16_t>(SubModelListEntry::VT_KMD_ID, kmd_id, 0); }
    void add_interface(eswin::loadable::Interface interface)
    {
        fbb_.AddElement<uint32_t>(SubModelListEntry::VT_INTERFACE, static_cast<uint32_t>(interface), 0);
    }
    void add_address_list(flatbuffers::Offset<flatbuffers::Vector<uint16_t>> address_list)
    {
        fbb_.AddOffset(SubModelListEntry::VT_ADDRESS_LIST, address_list);
    }
    explicit SubModelListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<SubModelListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<SubModelListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<SubModelListEntry> CreateSubModelListEntry(
    flatbuffers::FlatBufferBuilder &_fbb, uint16_t id = 0, int16_t kmd_id = 0,
    eswin::loadable::Interface interface = eswin::loadable::Interface_NONE,
    flatbuffers::Offset<flatbuffers::Vector<uint16_t>> address_list = 0)
{
    SubModelListEntryBuilder builder_(_fbb);
    builder_.add_address_list(address_list);
    builder_.add_interface(interface);
    builder_.add_kmd_id(kmd_id);
    builder_.add_id(id);
    return builder_.Finish();
}

inline flatbuffers::Offset<SubModelListEntry> CreateSubModelListEntryDirect(
    flatbuffers::FlatBufferBuilder &_fbb, uint16_t id = 0, int16_t kmd_id = 0,
    eswin::loadable::Interface interface = eswin::loadable::Interface_NONE,
    const std::vector<uint16_t> *address_list = nullptr)
{
    auto address_list__ = address_list ? _fbb.CreateVector<uint16_t>(*address_list) : 0;
    return eswin::loadable::CreateSubModelListEntry(_fbb, id, kmd_id, interface, address_list__);
}

struct AddressListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef AddressListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_ID = 4,
        VT_MEM_ID = 6,
        VT_OFFSET = 8,
        VT_SIZE = 10
    };
    uint16_t id() const { return GetField<uint16_t>(VT_ID, 0); }
    uint16_t mem_id() const { return GetField<uint16_t>(VT_MEM_ID, 0); }
    uint64_t offset() const { return GetField<uint64_t>(VT_OFFSET, 0); }
    uint64_t size() const { return GetField<uint64_t>(VT_SIZE, 0); }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyField<uint16_t>(verifier, VT_ID) &&
               VerifyField<uint16_t>(verifier, VT_MEM_ID) && VerifyField<uint64_t>(verifier, VT_OFFSET) &&
               VerifyField<uint64_t>(verifier, VT_SIZE) && verifier.EndTable();
    }
};

struct AddressListEntryBuilder {
    typedef AddressListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_id(uint16_t id) { fbb_.AddElement<uint16_t>(AddressListEntry::VT_ID, id, 0); }
    void add_mem_id(uint16_t mem_id) { fbb_.AddElement<uint16_t>(AddressListEntry::VT_MEM_ID, mem_id, 0); }
    void add_offset(uint64_t offset) { fbb_.AddElement<uint64_t>(AddressListEntry::VT_OFFSET, offset, 0); }
    void add_size(uint64_t size) { fbb_.AddElement<uint64_t>(AddressListEntry::VT_SIZE, size, 0); }
    explicit AddressListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<AddressListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<AddressListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<AddressListEntry> CreateAddressListEntry(flatbuffers::FlatBufferBuilder &_fbb,
                                                                    uint16_t id = 0, uint16_t mem_id = 0,
                                                                    uint64_t offset = 0, uint64_t size = 0)
{
    AddressListEntryBuilder builder_(_fbb);
    builder_.add_size(size);
    builder_.add_offset(offset);
    builder_.add_mem_id(mem_id);
    builder_.add_id(id);
    return builder_.Finish();
}

struct SubmitListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef SubmitListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_ID = 4,
        VT_TASK_ID = 6
    };
    uint16_t id() const { return GetField<uint16_t>(VT_ID, 0); }
    const flatbuffers::Vector<uint16_t> *task_id() const
    {
        return GetPointer<const flatbuffers::Vector<uint16_t> *>(VT_TASK_ID);
    }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyField<uint16_t>(verifier, VT_ID) &&
               VerifyOffset(verifier, VT_TASK_ID) && verifier.VerifyVector(task_id()) && verifier.EndTable();
    }
};

struct SubmitListEntryBuilder {
    typedef SubmitListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_id(uint16_t id) { fbb_.AddElement<uint16_t>(SubmitListEntry::VT_ID, id, 0); }
    void add_task_id(flatbuffers::Offset<flatbuffers::Vector<uint16_t>> task_id)
    {
        fbb_.AddOffset(SubmitListEntry::VT_TASK_ID, task_id);
    }
    explicit SubmitListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<SubmitListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<SubmitListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<SubmitListEntry> CreateSubmitListEntry(
    flatbuffers::FlatBufferBuilder &_fbb, uint16_t id = 0,
    flatbuffers::Offset<flatbuffers::Vector<uint16_t>> task_id = 0)
{
    SubmitListEntryBuilder builder_(_fbb);
    builder_.add_task_id(task_id);
    builder_.add_id(id);
    return builder_.Finish();
}

inline flatbuffers::Offset<SubmitListEntry> CreateSubmitListEntryDirect(flatbuffers::FlatBufferBuilder &_fbb,
                                                                        uint16_t id = 0,
                                                                        const std::vector<uint16_t> *task_id = nullptr)
{
    auto task_id__ = task_id ? _fbb.CreateVector<uint16_t>(*task_id) : 0;
    return eswin::loadable::CreateSubmitListEntry(_fbb, id, task_id__);
}

struct TensorDescListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef TensorDescListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_NAME = 4,
        VT_ID = 6,
        VT_MEM_ID = 8,
        VT_SIZE = 10,
        VT_OFFSET = 12,
        VT_DATA_FORMAT = 14,
        VT_DATA_TYPE = 16,
        VT_DATA_CATEGORY = 18,
        VT_PIXEL_FORMAT = 20,
        VT_PIXEL_MAPPING = 22,
        VT_N = 24,
        VT_C = 26,
        VT_H = 28,
        VT_W = 30,
        VT_STRIDE_0 = 32,
        VT_STRIDE_1 = 34,
        VT_STRIDE_2 = 36,
        VT_STRIDE_3 = 38,
        VT_STRIDE_4 = 40,
        VT_STRIDE_5 = 42,
        VT_STRIDE_6 = 44,
        VT_STRIDE_7 = 46
    };
    const flatbuffers::String *name() const { return GetPointer<const flatbuffers::String *>(VT_NAME); }
    uint16_t id() const { return GetField<uint16_t>(VT_ID, 0); }
    uint16_t mem_id() const { return GetField<uint16_t>(VT_MEM_ID, 0); }
    uint64_t size() const { return GetField<uint64_t>(VT_SIZE, 0); }
    uint64_t offset() const { return GetField<uint64_t>(VT_OFFSET, 0); }
    eswin::loadable::DataFormat data_format() const
    {
        return static_cast<eswin::loadable::DataFormat>(GetField<uint8_t>(VT_DATA_FORMAT, 0));
    }
    eswin::loadable::DataType data_type() const
    {
        return static_cast<eswin::loadable::DataType>(GetField<uint8_t>(VT_DATA_TYPE, 0));
    }
    eswin::loadable::DataCategory data_category() const
    {
        return static_cast<eswin::loadable::DataCategory>(GetField<uint8_t>(VT_DATA_CATEGORY, 0));
    }
    eswin::loadable::PixelFormat pixel_format() const
    {
        return static_cast<eswin::loadable::PixelFormat>(GetField<uint8_t>(VT_PIXEL_FORMAT, 0));
    }
    eswin::loadable::PixelMapping pixel_mapping() const
    {
        return static_cast<eswin::loadable::PixelMapping>(GetField<uint8_t>(VT_PIXEL_MAPPING, 0));
    }
    int32_t n() const { return GetField<int32_t>(VT_N, 0); }
    int32_t c() const { return GetField<int32_t>(VT_C, 0); }
    int32_t h() const { return GetField<int32_t>(VT_H, 0); }
    int32_t w() const { return GetField<int32_t>(VT_W, 0); }
    uint32_t stride_0() const { return GetField<uint32_t>(VT_STRIDE_0, 0); }
    uint32_t stride_1() const { return GetField<uint32_t>(VT_STRIDE_1, 0); }
    uint32_t stride_2() const { return GetField<uint32_t>(VT_STRIDE_2, 0); }
    uint32_t stride_3() const { return GetField<uint32_t>(VT_STRIDE_3, 0); }
    uint32_t stride_4() const { return GetField<uint32_t>(VT_STRIDE_4, 0); }
    uint32_t stride_5() const { return GetField<uint32_t>(VT_STRIDE_5, 0); }
    uint32_t stride_6() const { return GetField<uint32_t>(VT_STRIDE_6, 0); }
    uint32_t stride_7() const { return GetField<uint32_t>(VT_STRIDE_7, 0); }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyOffset(verifier, VT_NAME) && verifier.VerifyString(name()) &&
               VerifyField<uint16_t>(verifier, VT_ID) && VerifyField<uint16_t>(verifier, VT_MEM_ID) &&
               VerifyField<uint64_t>(verifier, VT_SIZE) && VerifyField<uint64_t>(verifier, VT_OFFSET) &&
               VerifyField<uint8_t>(verifier, VT_DATA_FORMAT) && VerifyField<uint8_t>(verifier, VT_DATA_TYPE) &&
               VerifyField<uint8_t>(verifier, VT_DATA_CATEGORY) && VerifyField<uint8_t>(verifier, VT_PIXEL_FORMAT) &&
               VerifyField<uint8_t>(verifier, VT_PIXEL_MAPPING) && VerifyField<int32_t>(verifier, VT_N) &&
               VerifyField<int32_t>(verifier, VT_C) && VerifyField<int32_t>(verifier, VT_H) &&
               VerifyField<int32_t>(verifier, VT_W) && VerifyField<uint32_t>(verifier, VT_STRIDE_0) &&
               VerifyField<uint32_t>(verifier, VT_STRIDE_1) && VerifyField<uint32_t>(verifier, VT_STRIDE_2) &&
               VerifyField<uint32_t>(verifier, VT_STRIDE_3) && VerifyField<uint32_t>(verifier, VT_STRIDE_4) &&
               VerifyField<uint32_t>(verifier, VT_STRIDE_5) && VerifyField<uint32_t>(verifier, VT_STRIDE_6) &&
               VerifyField<uint32_t>(verifier, VT_STRIDE_7) && verifier.EndTable();
    }
};

struct TensorDescListEntryBuilder {
    typedef TensorDescListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_name(flatbuffers::Offset<flatbuffers::String> name) { fbb_.AddOffset(TensorDescListEntry::VT_NAME, name); }
    void add_id(uint16_t id) { fbb_.AddElement<uint16_t>(TensorDescListEntry::VT_ID, id, 0); }
    void add_mem_id(uint16_t mem_id) { fbb_.AddElement<uint16_t>(TensorDescListEntry::VT_MEM_ID, mem_id, 0); }
    void add_size(uint64_t size) { fbb_.AddElement<uint64_t>(TensorDescListEntry::VT_SIZE, size, 0); }
    void add_offset(uint64_t offset) { fbb_.AddElement<uint64_t>(TensorDescListEntry::VT_OFFSET, offset, 0); }
    void add_data_format(eswin::loadable::DataFormat data_format)
    {
        fbb_.AddElement<uint8_t>(TensorDescListEntry::VT_DATA_FORMAT, static_cast<uint8_t>(data_format), 0);
    }
    void add_data_type(eswin::loadable::DataType data_type)
    {
        fbb_.AddElement<uint8_t>(TensorDescListEntry::VT_DATA_TYPE, static_cast<uint8_t>(data_type), 0);
    }
    void add_data_category(eswin::loadable::DataCategory data_category)
    {
        fbb_.AddElement<uint8_t>(TensorDescListEntry::VT_DATA_CATEGORY, static_cast<uint8_t>(data_category), 0);
    }
    void add_pixel_format(eswin::loadable::PixelFormat pixel_format)
    {
        fbb_.AddElement<uint8_t>(TensorDescListEntry::VT_PIXEL_FORMAT, static_cast<uint8_t>(pixel_format), 0);
    }
    void add_pixel_mapping(eswin::loadable::PixelMapping pixel_mapping)
    {
        fbb_.AddElement<uint8_t>(TensorDescListEntry::VT_PIXEL_MAPPING, static_cast<uint8_t>(pixel_mapping), 0);
    }
    void add_n(int32_t n) { fbb_.AddElement<int32_t>(TensorDescListEntry::VT_N, n, 0); }
    void add_c(int32_t c) { fbb_.AddElement<int32_t>(TensorDescListEntry::VT_C, c, 0); }
    void add_h(int32_t h) { fbb_.AddElement<int32_t>(TensorDescListEntry::VT_H, h, 0); }
    void add_w(int32_t w) { fbb_.AddElement<int32_t>(TensorDescListEntry::VT_W, w, 0); }
    void add_stride_0(uint32_t stride_0) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_0, stride_0, 0); }
    void add_stride_1(uint32_t stride_1) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_1, stride_1, 0); }
    void add_stride_2(uint32_t stride_2) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_2, stride_2, 0); }
    void add_stride_3(uint32_t stride_3) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_3, stride_3, 0); }
    void add_stride_4(uint32_t stride_4) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_4, stride_4, 0); }
    void add_stride_5(uint32_t stride_5) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_5, stride_5, 0); }
    void add_stride_6(uint32_t stride_6) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_6, stride_6, 0); }
    void add_stride_7(uint32_t stride_7) { fbb_.AddElement<uint32_t>(TensorDescListEntry::VT_STRIDE_7, stride_7, 0); }
    explicit TensorDescListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb)
    {
        start_ = fbb_.StartTable();
    }
    flatbuffers::Offset<TensorDescListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<TensorDescListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<TensorDescListEntry> CreateTensorDescListEntry(
    flatbuffers::FlatBufferBuilder &_fbb, flatbuffers::Offset<flatbuffers::String> name = 0, uint16_t id = 0,
    uint16_t mem_id = 0, uint64_t size = 0, uint64_t offset = 0,
    eswin::loadable::DataFormat data_format = eswin::loadable::DataFormat_UNKNOWN,
    eswin::loadable::DataType data_type = eswin::loadable::DataType_UNKNOWN,
    eswin::loadable::DataCategory data_category = eswin::loadable::DataCategory_IMAGE,
    eswin::loadable::PixelFormat pixel_format = eswin::loadable::PixelFormat_R8,
    eswin::loadable::PixelMapping pixel_mapping = eswin::loadable::PixelMapping_PITCH_LINEAR, int32_t n = 0,
    int32_t c = 0, int32_t h = 0, int32_t w = 0, uint32_t stride_0 = 0, uint32_t stride_1 = 0, uint32_t stride_2 = 0,
    uint32_t stride_3 = 0, uint32_t stride_4 = 0, uint32_t stride_5 = 0, uint32_t stride_6 = 0, uint32_t stride_7 = 0)
{
    TensorDescListEntryBuilder builder_(_fbb);
    builder_.add_offset(offset);
    builder_.add_size(size);
    builder_.add_stride_7(stride_7);
    builder_.add_stride_6(stride_6);
    builder_.add_stride_5(stride_5);
    builder_.add_stride_4(stride_4);
    builder_.add_stride_3(stride_3);
    builder_.add_stride_2(stride_2);
    builder_.add_stride_1(stride_1);
    builder_.add_stride_0(stride_0);
    builder_.add_w(w);
    builder_.add_h(h);
    builder_.add_c(c);
    builder_.add_n(n);
    builder_.add_name(name);
    builder_.add_mem_id(mem_id);
    builder_.add_id(id);
    builder_.add_pixel_mapping(pixel_mapping);
    builder_.add_pixel_format(pixel_format);
    builder_.add_data_category(data_category);
    builder_.add_data_type(data_type);
    builder_.add_data_format(data_format);
    return builder_.Finish();
}

inline flatbuffers::Offset<TensorDescListEntry> CreateTensorDescListEntryDirect(
    flatbuffers::FlatBufferBuilder &_fbb, const char *name = nullptr, uint16_t id = 0, uint16_t mem_id = 0,
    uint64_t size = 0, uint64_t offset = 0,
    eswin::loadable::DataFormat data_format = eswin::loadable::DataFormat_UNKNOWN,
    eswin::loadable::DataType data_type = eswin::loadable::DataType_UNKNOWN,
    eswin::loadable::DataCategory data_category = eswin::loadable::DataCategory_IMAGE,
    eswin::loadable::PixelFormat pixel_format = eswin::loadable::PixelFormat_R8,
    eswin::loadable::PixelMapping pixel_mapping = eswin::loadable::PixelMapping_PITCH_LINEAR, int32_t n = 0,
    int32_t c = 0, int32_t h = 0, int32_t w = 0, uint32_t stride_0 = 0, uint32_t stride_1 = 0, uint32_t stride_2 = 0,
    uint32_t stride_3 = 0, uint32_t stride_4 = 0, uint32_t stride_5 = 0, uint32_t stride_6 = 0, uint32_t stride_7 = 0)
{
    auto name__ = name ? _fbb.CreateString(name) : 0;
    return eswin::loadable::CreateTensorDescListEntry(
        _fbb, name__, id, mem_id, size, offset, data_format, data_type, data_category, pixel_format, pixel_mapping, n,
        c, h, w, stride_0, stride_1, stride_2, stride_3, stride_4, stride_5, stride_6, stride_7);
}

struct RelocListEntry FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef RelocListEntryBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_ADDRESS_ID = 4,
        VT_WRITE_ID = 6,
        VT_OFFSET = 8,
        VT_INTERFACE = 10,
        VT_SUB_INTERFACE = 12,
        VT_RELOC_TYPE = 14
    };
    uint16_t address_id() const { return GetField<uint16_t>(VT_ADDRESS_ID, 0); }
    uint16_t write_id() const { return GetField<uint16_t>(VT_WRITE_ID, 0); }
    uint64_t offset() const { return GetField<uint64_t>(VT_OFFSET, 0); }
    uint32_t interface() const { return GetField<uint32_t>(VT_INTERFACE, 0); }
    uint32_t sub_interface() const { return GetField<uint32_t>(VT_SUB_INTERFACE, 0); }
    uint8_t reloc_type() const { return GetField<uint8_t>(VT_RELOC_TYPE, 0); }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyField<uint16_t>(verifier, VT_ADDRESS_ID) &&
               VerifyField<uint16_t>(verifier, VT_WRITE_ID) && VerifyField<uint64_t>(verifier, VT_OFFSET) &&
               VerifyField<uint32_t>(verifier, VT_INTERFACE) && VerifyField<uint32_t>(verifier, VT_SUB_INTERFACE) &&
               VerifyField<uint8_t>(verifier, VT_RELOC_TYPE) && verifier.EndTable();
    }
};

struct RelocListEntryBuilder {
    typedef RelocListEntry Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_address_id(uint16_t address_id)
    {
        fbb_.AddElement<uint16_t>(RelocListEntry::VT_ADDRESS_ID, address_id, 0);
    }
    void add_write_id(uint16_t write_id) { fbb_.AddElement<uint16_t>(RelocListEntry::VT_WRITE_ID, write_id, 0); }
    void add_offset(uint64_t offset) { fbb_.AddElement<uint64_t>(RelocListEntry::VT_OFFSET, offset, 0); }
    void add_interface(uint32_t interface) { fbb_.AddElement<uint32_t>(RelocListEntry::VT_INTERFACE, interface, 0); }
    void add_sub_interface(uint32_t sub_interface)
    {
        fbb_.AddElement<uint32_t>(RelocListEntry::VT_SUB_INTERFACE, sub_interface, 0);
    }
    void add_reloc_type(uint8_t reloc_type) { fbb_.AddElement<uint8_t>(RelocListEntry::VT_RELOC_TYPE, reloc_type, 0); }
    explicit RelocListEntryBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<RelocListEntry> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<RelocListEntry>(end);
        return o;
    }
};

inline flatbuffers::Offset<RelocListEntry> CreateRelocListEntry(flatbuffers::FlatBufferBuilder &_fbb,
                                                                uint16_t address_id = 0, uint16_t write_id = 0,
                                                                uint64_t offset = 0, uint32_t interface = 0,
                                                                uint32_t sub_interface = 0, uint8_t reloc_type = 0)
{
    RelocListEntryBuilder builder_(_fbb);
    builder_.add_offset(offset);
    builder_.add_sub_interface(sub_interface);
    builder_.add_interface(interface);
    builder_.add_write_id(write_id);
    builder_.add_address_id(address_id);
    builder_.add_reloc_type(reloc_type);
    return builder_.Finish();
}

struct Loadable FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
    typedef LoadableBuilder Builder;
    enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
        VT_VERSION = 4,
        VT_TASK_LIST = 6,
        VT_MEMORY_LIST = 8,
        VT_ADDRESS_LIST = 10,
        VT_EVENT_LIST = 12,
        VT_BLOBS = 14,
        VT_TENSOR_DESC_LIST = 16,
        VT_RELOC_LIST = 18,
        VT_SUBMIT_LIST = 20
    };
    const eswin::loadable::Version *version() const { return GetStruct<const eswin::loadable::Version *>(VT_VERSION); }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubModelListEntry>> *task_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubModelListEntry>> *>(
            VT_TASK_LIST);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::MemoryListEntry>> *memory_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::MemoryListEntry>> *>(
            VT_MEMORY_LIST);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::AddressListEntry>> *address_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::AddressListEntry>> *>(
            VT_ADDRESS_LIST);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::EventListEntry>> *event_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::EventListEntry>> *>(
            VT_EVENT_LIST);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::Blob>> *blobs() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::Blob>> *>(VT_BLOBS);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::TensorDescListEntry>> *tensor_desc_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::TensorDescListEntry>> *>(
            VT_TENSOR_DESC_LIST);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::RelocListEntry>> *reloc_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::RelocListEntry>> *>(
            VT_RELOC_LIST);
    }
    const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubmitListEntry>> *submit_list() const
    {
        return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubmitListEntry>> *>(
            VT_SUBMIT_LIST);
    }
    bool Verify(flatbuffers::Verifier &verifier) const
    {
        return VerifyTableStart(verifier) && VerifyFieldRequired<eswin::loadable::Version>(verifier, VT_VERSION) &&
               VerifyOffset(verifier, VT_TASK_LIST) && verifier.VerifyVector(task_list()) &&
               verifier.VerifyVectorOfTables(task_list()) && VerifyOffset(verifier, VT_MEMORY_LIST) &&
               verifier.VerifyVector(memory_list()) && verifier.VerifyVectorOfTables(memory_list()) &&
               VerifyOffset(verifier, VT_ADDRESS_LIST) && verifier.VerifyVector(address_list()) &&
               verifier.VerifyVectorOfTables(address_list()) && VerifyOffset(verifier, VT_EVENT_LIST) &&
               verifier.VerifyVector(event_list()) && verifier.VerifyVectorOfTables(event_list()) &&
               VerifyOffset(verifier, VT_BLOBS) && verifier.VerifyVector(blobs()) &&
               verifier.VerifyVectorOfTables(blobs()) && VerifyOffset(verifier, VT_TENSOR_DESC_LIST) &&
               verifier.VerifyVector(tensor_desc_list()) && verifier.VerifyVectorOfTables(tensor_desc_list()) &&
               VerifyOffset(verifier, VT_RELOC_LIST) && verifier.VerifyVector(reloc_list()) &&
               verifier.VerifyVectorOfTables(reloc_list()) && VerifyOffset(verifier, VT_SUBMIT_LIST) &&
               verifier.VerifyVector(submit_list()) && verifier.VerifyVectorOfTables(submit_list()) &&
               verifier.EndTable();
    }
};

struct LoadableBuilder {
    typedef Loadable Table;
    flatbuffers::FlatBufferBuilder &fbb_;
    flatbuffers::uoffset_t start_;
    void add_version(const eswin::loadable::Version *version) { fbb_.AddStruct(Loadable::VT_VERSION, version); }
    void add_task_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubModelListEntry>>> task_list)
    {
        fbb_.AddOffset(Loadable::VT_TASK_LIST, task_list);
    }
    void add_memory_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::MemoryListEntry>>> memory_list)
    {
        fbb_.AddOffset(Loadable::VT_MEMORY_LIST, memory_list);
    }
    void add_address_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::AddressListEntry>>> address_list)
    {
        fbb_.AddOffset(Loadable::VT_ADDRESS_LIST, address_list);
    }
    void add_event_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::EventListEntry>>> event_list)
    {
        fbb_.AddOffset(Loadable::VT_EVENT_LIST, event_list);
    }
    void add_blobs(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::Blob>>> blobs)
    {
        fbb_.AddOffset(Loadable::VT_BLOBS, blobs);
    }
    void add_tensor_desc_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::TensorDescListEntry>>>
            tensor_desc_list)
    {
        fbb_.AddOffset(Loadable::VT_TENSOR_DESC_LIST, tensor_desc_list);
    }
    void add_reloc_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::RelocListEntry>>> reloc_list)
    {
        fbb_.AddOffset(Loadable::VT_RELOC_LIST, reloc_list);
    }
    void add_submit_list(
        flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubmitListEntry>>> submit_list)
    {
        fbb_.AddOffset(Loadable::VT_SUBMIT_LIST, submit_list);
    }
    explicit LoadableBuilder(flatbuffers::FlatBufferBuilder &_fbb) : fbb_(_fbb) { start_ = fbb_.StartTable(); }
    flatbuffers::Offset<Loadable> Finish()
    {
        const auto end = fbb_.EndTable(start_);
        auto o = flatbuffers::Offset<Loadable>(end);
        fbb_.Required(o, Loadable::VT_VERSION);
        return o;
    }
};

inline flatbuffers::Offset<Loadable> CreateLoadable(
    flatbuffers::FlatBufferBuilder &_fbb, const eswin::loadable::Version *version = nullptr,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubModelListEntry>>> task_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::MemoryListEntry>>> memory_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::AddressListEntry>>> address_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::EventListEntry>>> event_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::Blob>>> blobs = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::TensorDescListEntry>>>
        tensor_desc_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::RelocListEntry>>> reloc_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<eswin::loadable::SubmitListEntry>>> submit_list = 0)
{
    LoadableBuilder builder_(_fbb);
    builder_.add_submit_list(submit_list);
    builder_.add_reloc_list(reloc_list);
    builder_.add_tensor_desc_list(tensor_desc_list);
    builder_.add_blobs(blobs);
    builder_.add_event_list(event_list);
    builder_.add_address_list(address_list);
    builder_.add_memory_list(memory_list);
    builder_.add_task_list(task_list);
    builder_.add_version(version);
    return builder_.Finish();
}

inline flatbuffers::Offset<Loadable> CreateLoadableDirect(
    flatbuffers::FlatBufferBuilder &_fbb, const eswin::loadable::Version *version = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::SubModelListEntry>> *task_list = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::MemoryListEntry>> *memory_list = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::AddressListEntry>> *address_list = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::EventListEntry>> *event_list = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::Blob>> *blobs = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::TensorDescListEntry>> *tensor_desc_list = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::RelocListEntry>> *reloc_list = nullptr,
    const std::vector<flatbuffers::Offset<eswin::loadable::SubmitListEntry>> *submit_list = nullptr)
{
    auto task_list__ =
        task_list ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::SubModelListEntry>>(*task_list) : 0;
    auto memory_list__ =
        memory_list ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::MemoryListEntry>>(*memory_list) : 0;
    auto address_list__ =
        address_list ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::AddressListEntry>>(*address_list) : 0;
    auto event_list__ =
        event_list ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::EventListEntry>>(*event_list) : 0;
    auto blobs__ = blobs ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::Blob>>(*blobs) : 0;
    auto tensor_desc_list__ =
        tensor_desc_list
            ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::TensorDescListEntry>>(*tensor_desc_list)
            : 0;
    auto reloc_list__ =
        reloc_list ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::RelocListEntry>>(*reloc_list) : 0;
    auto submit_list__ =
        submit_list ? _fbb.CreateVector<flatbuffers::Offset<eswin::loadable::SubmitListEntry>>(*submit_list) : 0;
    return eswin::loadable::CreateLoadable(_fbb, version, task_list__, memory_list__, address_list__, event_list__,
                                           blobs__, tensor_desc_list__, reloc_list__, submit_list__);
}

inline const eswin::loadable::Loadable *GetLoadable(const void *buf)
{
    return flatbuffers::GetRoot<eswin::loadable::Loadable>(buf);
}

inline const eswin::loadable::Loadable *GetSizePrefixedLoadable(const void *buf)
{
    return flatbuffers::GetSizePrefixedRoot<eswin::loadable::Loadable>(buf);
}

inline bool VerifyLoadableBuffer(flatbuffers::Verifier &verifier)
{
    return verifier.VerifyBuffer<eswin::loadable::Loadable>(nullptr);
}

inline bool VerifySizePrefixedLoadableBuffer(flatbuffers::Verifier &verifier)
{
    return verifier.VerifySizePrefixedBuffer<eswin::loadable::Loadable>(nullptr);
}

inline void FinishLoadableBuffer(flatbuffers::FlatBufferBuilder &fbb,
                                 flatbuffers::Offset<eswin::loadable::Loadable> root)
{
    fbb.Finish(root);
}

inline void FinishSizePrefixedLoadableBuffer(flatbuffers::FlatBufferBuilder &fbb,
                                             flatbuffers::Offset<eswin::loadable::Loadable> root)
{
    fbb.FinishSizePrefixed(root);
}

}  // namespace loadable
}  // namespace eswin

#endif  // ESWIN_HOST_RUNTIME_INCLUDE_LOADABLE_GENERATED_H_
