// Copyright © 2024 ESWIN. All rights reserved.
//
// Beijing ESWIN Computing Technology Co., Ltd and its affiliated companies ("ESWIN") retain
// all intellectual property and proprietary rights in and to this software. Except as expressly
// authorized by ESWIN, no part of the software may be released, copied, distributed, reproduced,
// modified, adapted, translated, or created derivative work of, in whole or in part.

#ifndef _HWPREPROCESS_H
#define _HWPREPROCESS_H

#include "preprocess.h"
#include <string>
#include <atomic>
#include "sample_comm.h"

class EsHwPreProcess : public EsPreProcess
{
 public:
    EsHwPreProcess();
    virtual ~EsHwPreProcess();

 public:
    bool initializeFromJson(uint32_t devId, const std::string &cfgFilePath) override;
    int32_t preprocess(const std::string &jpegPath, uint64_t fd, uint64_t offset, uint64_t size) override;
    void release() override;

 private:
    ES_S32 mGrpCount;
    ES_S32 mGrpId;
    ES_S32 mChnId;

    VPS_NORMALIZATION_PARAMS_S mNormParams;
    static std::atomic<bool> mInit;
};

#endif  // _PREPROCESS_H
